; Copyright (C) 2018-2019 Francis (Fritz) Mahnke.

; This file is part of c64-3d-graphics-series.

; c64-3d-graphics-series is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.

; c64-3d-graphics-series is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with c64-3d-graphics-series.  If not, see
; <https://www.gnu.org/licenses/>.

    !source "loader.asm"

pen_addr_lo = $2e
pen_addr_hi = $2f
pen_row_loc = $31
pen_pixel_bit = $32
arg0 = $33
arg1 = $34
arg2 = $35
arg3 = $36

    +start_at $0900

    jmp start

    !source "prelude.asm"
    !source "display.asm"
    !source "pen.asm"

start:
    sei

    ; Put bitmap at 8192

    lda $d018
    ora #$08
    sta $d018

    ; Turn on standard bitmap mode

    lda $d011
    ora #$20
    sta $d011

    ; Set display memory colors to black and cyan.

    +disp_fill $30
    +bitmap_fill $00

    ; Test pen_move_left

    jsr pen_init

    +push_reg
    lda #$00
    sta arg0
    lda #$ff
    sta arg1
    jsr pen_move_to
    +pull_reg

    ldy #$02
    ldx #$ff

-   +push_reg
    jsr pen_px_set
    +pull_reg

    +push_reg
    jsr pen_move_left
    +pull_reg

    dex
    bne -

    ldx #$40
    dey
    bne -

    ; Test pen_move_right

    jsr pen_init

    +push_reg
    lda #$02
    sta arg0
    lda #$00
    sta arg1
    jsr pen_move_to
    +pull_reg

    ldy #$02
    ldx #$ff

-   +push_reg
    jsr pen_px_set
    +pull_reg

    +push_reg
    jsr pen_move_right
    +pull_reg

    dex
    bne -

    ldx #$40
    dey
    bne -

    ; Test pen_move_down

    jsr pen_init

    +push_reg
    lda #$00
    sta arg0
    lda #$00
    sta arg1
    jsr pen_move_to
    +pull_reg

    ldx #$c8

-   +push_reg
    jsr pen_px_set
    +pull_reg

    +push_reg
    jsr pen_move_down
    +pull_reg

    dex
    bne -

    ; Test pen_move_up

    jsr pen_init

    +push_reg
    lda #$c7
    sta arg0
    lda #$02
    sta arg1
    jsr pen_move_to
    +pull_reg

    ldx #$c8

-   +push_reg
    jsr pen_px_set
    +pull_reg

    +push_reg
    jsr pen_move_up
    +pull_reg

    dex
    bne -

-   nop
    jmp -
